Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 1679)
@@ -57,6 +57,8 @@
     txtImmedColl: TCaptionEdit;
     pnlCollTimeButton: TKeyClickPanel;
+    lblTNS: TLabel;
+    lblNoBloodReq: TLabel;
     cmdImmedColl: TSpeedButton;
-    lblTNS: TLabel;
+    Splitter1: TSplitter;
     procedure FormCreate(Sender: TObject);
     procedure cboAvailTestSelect(Sender: TObject);
@@ -97,8 +99,23 @@
     procedure cboModifiersChange(Sender: TObject);
     procedure lvSelectionListClick(Sender: TObject);
-    procedure cboAvailCompChange(Sender: TObject);
     procedure cboCollTimeChange(Sender: TObject);
     procedure memDiagCommentChange(Sender: TObject);
     procedure cboUrgencyExit(Sender: TObject);
+    procedure pnlBloodComponentsEnter(Sender: TObject);
+    procedure pnlDiagnosticTestsEnter(Sender: TObject);
+    procedure pnlDiagnosticTestsExit(Sender: TObject);
+    procedure pnlBloodComponentsExit(Sender: TObject);
+    procedure pnlBloodComponentsClick(Sender: TObject);
+    procedure pnlDiagnosticTestsClick(Sender: TObject);
+    procedure cboCollTypeClick(Sender: TObject);
+    procedure cboAvailTestEnter(Sender: TObject);
+    procedure cboCollTypeEnter(Sender: TObject);
+    procedure txtImmedCollEnter(Sender: TObject);
+    procedure calCollTimeEnter(Sender: TObject);
+    procedure cboCollTimeEnter(Sender: TObject);
+    procedure cboModifiersEnter(Sender: TObject);
+    procedure calWantTimeEnter(Sender: TObject);
+    procedure cboAvailCompEnter(Sender: TObject);
+    procedure FormShow(Sender: TObject);
   protected
     FCmtTypes: TStringList ;
@@ -244,4 +261,5 @@
   ALabTest: TLabTest;
   UserHasLRLABKey: boolean;
+  uChangingMSBOS: boolean;
   LRFZX     : string;  //the default collection type  (LC,WC,SP,I)
   LRFSAMP   : string;  //the default sample           (ptr)
@@ -293,4 +311,5 @@
   uSelUrgency := '';
   uSelSurgery := 0;
+  uChangingMSBOS := false;
   TabResults.Caption := 'Lab Results';
   edtResults.Lines.Clear;
@@ -314,4 +333,18 @@
     UserHasLRLABKey := User.HasKey('LRLAB');
     AllowQuickOrder := True;
+    if GetDiagnosticPanelLocation then
+      begin
+        pnlDiagnosticTests.Left := 0;
+        pnlBloodComponents.Left := (pnlDiagnosticTests.Width + 10);
+        pnlDiagnosticTests.TabOrder := 0;
+        pnlBloodComponents.TabOrder := 1;
+      end
+    else
+      begin
+        pnlBloodComponents.Left := 0;
+        pnlDiagnosticTests.Left := (pnlBloodComponents.Width + 10);
+        pnlBloodComponents.TabOrder := 0;
+        pnlDiagnosticTests.TabOrder := 1;
+      end;
     StatusText('Loading Dialog Definition');
     FCmtTypes := TStringList.Create;
@@ -342,9 +375,11 @@
       else
         cboCollType.SelectByID('SP');
-      SetupCollTimes(cboCollType.ItemID);
-      StatusText('Initializing List of Tests');
-      FVbecLookup := 'S.VBT';
-      cboAvailTest.InitLongList('');      //Populates cboAvailTest control based on S.VBT xref
-    end;
+      //SetupCollTimes(cboCollType.ItemID);
+    end;
+    cboAvailTest.Clear;
+    aList.Clear;
+    GetDiagnosticTests(aList);            //Get Tests in right order
+    for i := 0 to aList.Count - 1 do
+      cboAvailTest.Items.Add(aList[i]);
     cboAvailComp.Clear;
     aList.Clear;
@@ -365,5 +400,5 @@
     AList.Clear;
     ExtractUrgencies(uUrgencyList, uVBECList);
-    ExtractTNSOrders(uTNSOrders, uVBECList);
+    if not(self.EvtID > 0) then ExtractTNSOrders(uTNSOrders, uVBECList);
     LoadUrgencies(cboUrgency);
     ExtractModifiers(uModifierList, uVBECList);
@@ -371,5 +406,4 @@
     LoadModifiers(cboModifiers);
     LoadReasons(cboReasons);
-    calWantTime.Text := 'NOW'; //FormatFMDateTime('mmm dd,yyyy@hh:nn',DateTimeToFMDateTime(Now));
     pgeProduct.TabIndex := TI_INFO;
     lvSelectionList.Column[0].Width := 240;
@@ -378,4 +412,5 @@
     DisableComponentControls;
     DisableDiagTestControls;
+    pnlDiagnosticTests.Caption := 'Diagnostic Tests';
     pgeProduct.ActivePageIndex := TI_INFO;
     StatusText('');
@@ -425,13 +460,17 @@
   AnInstance, CurAdd: Integer;
   AResponse: TResponse;
-  i, j, k, aTNS, aTNSDays, getTest, TestAdded: integer;
-  aStr, aTestYes, aName, aTypeScreen, aSpecimen, aModifier, sub, sub1, x, aTNSString: string;
+  i, j, k, aTNS, getTest, TestAdded, aMSBOSContinue: integer;
+  aStr, aTestYes, aName, aTypeScreen, aSpecimen, aSpecimenUID, aSpecimenReq, aModifier, sub, sub1, x, aTNSString, aUrgText: string;
   ListItem: TListItem;
-  aList: TStringList;
+  aList, cList: TStringList;
   aTests: TStringList;
+  xLabTest: TLabTest;
+  aGotTNS : Boolean;
 begin
   inherited;
   aList := TStringList.Create;
+  cList := TStringList.Create;
   aTests:= TStringList.Create;
+  aGotTNS := false;
   try
   FOrderAction := OrderAction;
@@ -439,8 +478,11 @@
   sub1 := '';
   aTypeScreen := '';
-  aSpecimen := '^';
+  aSpecimen := '';
+  aSpecimenUID := '';
+  aSpecimenReq := '';
   aModifier := '';
   if OrderAction in [ORDER_COPY, ORDER_EDIT, ORDER_QUICK] then with Responses, ALabTest do
     begin
+      pgeProduct.ActivePageIndex := TI_COMPONENT;
       AnInstance := NextInstance('ORDERABLE', 0);
       while AnInstance > 0 do
@@ -453,5 +495,7 @@
                 begin
                   SetControl(cboAvailTest,        'ORDERABLE', AnInstance);
-                  ALabTest := TLabTest.Create(cboAvailTest.ItemID, Responses);
+                  changing := true;
+                  cboAvailTestSelect(Self);
+                  changing := false;
                 end
               else
@@ -468,9 +512,13 @@
                   SetControl(chkConsent,         'YN', AnInstance);
                   //DetermineCollectionDefaults(Responses);
-                  SetControl(cboCollType,        'COLLECT', AnInstance);
-                  SetControl(cboCollTime,        'START', AnInstance);
-                  SetupCollTimes(cboCollType.ItemID);
+                  SetControl(cboSurgery,         'MISC', AnInstance);
                   SetControl(cboUrgency,         'URGENCY', AnInstance);
-                  SetControl(cboSurgery,         'MISC', AnInstance);
+                  if cboUrgency.ItemIEN = 0 then
+                    begin
+                      if StrToIntDef(LRFURG, 0) > 0 then
+                        cboUrgency.SelectByID(LRFURG)
+                      else if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
+                        cboUrgency.ItemIndex := 0;
+                    end;
                   Urgency := cboUrgency.ItemIEN;
                   if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
@@ -487,4 +535,5 @@
                       AResponse := Responses.FindResponseByName('COMMENT',i);
                     end ;
+                  cboUrgencyChange(self);
                 end;
               if sub = 't' then with ALabTest do      //DIAGNOSTIC TEST
@@ -494,4 +543,5 @@
                   EnableDiagTestControls;
                   LRORDERMODE := TORDER_MODE_DIAG;
+                  //DetermineCollectionDefaults(Responses);
                   aList.Clear;
                   aTestYes := '1';
@@ -499,74 +549,23 @@
                   if aList.Count > 0 then aTypeScreen := aList[0];
                   aList.Clear;
-                  with lvSelectionList do
-                    begin
-                      ListItem := Items.Add;
-                      ListItem.Caption := piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',2);
-                      ListItem.SubItems.Add('');
-                      ListItem.SubItems.Add('');
-                      ListItem.SubItems.Add('');
-                      ListItem.SubItems.Add(piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1));
-                      if piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1) = aTypeScreen then
-                        begin
-                          lblTNS.Caption := '';
-                          lblTNS.Visible := false;
-                          memMessage.Text := '';
-                          pnlMessage.Visible := false;
-                          uGetTnS := 0;
-                          pnlDiagnosticTests.Caption := 'Diagnostic Tests';
-                        end;
-                    end;
-                  aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
-                  uSelectedItems.Add(aStr);
                   if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
-                  {with cboCollType do if Length(ItemID) > 0 then
-                    begin
-                      Responses.Update('COLLECT', 1, ItemID, ItemID) ;
-                      FLastCollType := ItemID;
-                    end;  }
-                  if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+                  if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
+                    else
+                      begin
+                        cboUrgency.ItemIndex := 2;
+                        for i := 0 to cboUrgency.Items.Count - 1 do
+                          begin
+                            aUrgText := cboUrgency.Items[i];
+                            if aUrgText = '9^ROUTINE' then    // Find urgency default of ROUTINE
+                              begin
+                                cboUrgency.ItemIndex := i;
+                                break;
+                              end;
+                          end;
+                        Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+                        cboUrgencyChange(self);
+                      end;
                   if Length(memDiagComment.Text) > 0 then Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
                   if Length(cboReasons.Text) > 0 then Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
-                  LoadCollType(cboCollType);
-                  if (cboCollType.ItemID = 'LC') or (cboCollType.ItemID = 'I') then
-                    if not(ALabTest.LabCanCollect) and OrderForInpatient then
-                      cboCollType.SelectByID('WC')
-                    else if not(ALabTest.LabCanCollect) then
-                      cboCollType.SelectByID('SP');
-                  SetupCollTimes(cboCollType.ItemID);
-                  if cboCollType.ItemID = 'LC' then
-                    begin
-                      with cboCollTime do
-                        if Length(ItemID) > 0 then
-                          begin
-                            Responses.Update('START', 1, Copy(ItemID, 2, 999), Copy(ItemID, 2, 999));
-                            FLastLabCollTime := ItemID + U + Text;
-                          end
-                        else if Length(Text) > 0 then
-                          begin
-                            Responses.Update('START', 1, ValidCollTime(Text), Text) ;
-                            FLastLabCollTime := ValidCollTime(Text);
-                          end;
-                    end
-                  else
-                    begin
-                      with calCollTime do
-                        if FMDateTime > 0 then
-                          begin
-                            Responses.Update('START', 1, ValidCollTime(Text), Text);
-                            FLastColltime := ValidCollTime(Text);
-                          end
-                        else
-                          begin
-                            Responses.Update('START', 1, '', '') ;
-                            FLastCollTime := '';
-                          end;
-                    end;
-                  with cboCollType do if Length(ItemID) > 0 then
-                    begin
-                      Responses.Update('COLLECT', 1, ItemID, ItemID) ;
-                      FLastCollType := ItemID;
-                    end;
-                  //if Length(cboCollType.Text) > 0 then Responses.Update('COLLECT',1,cboCollType.ItemID,cboCollType.ItemID);
                   memOrder.Text := Responses.OrderText;
                   Changing := False;
@@ -625,11 +624,14 @@
                     if TestAdded = 1 then
                       begin
-                        edtResults.Clear;
                         aTests.Clear;
                         GetPatientBloodResults(aTests, Patient.DFN, uTestsForResults);
-                        QuickCopy(ATests,edtResults);
-                        if edtResults.Lines.Count > 0 then TabResults.Caption := 'Lab Results Available'; //TabResults.ImageIndex := 1;
-                        uRaw.Clear;
-                        GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+                        if aTests.Count > 0 then
+                          begin
+                            edtResults.Clear;
+                            QuickCopy(ATests,edtResults);
+                            TabResults.Caption := 'Lab Results Available';
+                            uRaw.Clear;
+                            GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+                          end;
                       end;
                     CurAdd := 1;
@@ -640,4 +642,33 @@
                         Inc(CurAdd);
                       end;
+                  for i := lvSelectionList.Items.Count - 1 downto 0 do
+                    begin
+                      if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
+                        begin
+                          aGotTNS := true;
+                          break;
+                        end;
+                    end;
+                  if (uTNSOrders.Count < 1) and (aGotTNS = false) and (SpecimenNeeded(aList, uVBECList, aLabTest.ItemID)) then  //check to see if type and screen is needed CQ 17349
+                    begin
+                      uGetTnS := 1;
+                    end;
+                  if aList.Count > 0 then
+                    begin
+                      aSpecimen := piece(aList[0], '^',1);
+                      aSpecimenUID := piece(aList[0], '^',2);
+                    end;
+                  aList.Clear;
+                  ExtractSpecimens(aList, uVBECList);    //Get specimen values to pass back to Server
+                  for i := 0 to aList.Count - 1 do
+                    begin
+                      if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID) then
+                        begin
+                          aSpecimenReq := piece(aList[i],'^',2);
+                          if (SpecimenNeeded(aList, uVBECList, aLabTest.ItemID)) then
+                            aSpecimenUID := '';
+                          break;
+                        end;
+                    end;
                   with lvSelectionList do
                     begin
@@ -657,8 +688,18 @@
                       ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
                     end;
-                  aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
+                  aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimenReq + '^' + aSpecimen + '^' + aSpecimenUID + '^' + IntToStr(aLabTest.ItemID);
                   uSelectedItems.Add(aStr);
                   memOrder.Text := Responses.OrderText;
                   Changing := False;
+                  if (Length(cboSurgery.Text) > 0) then
+                    begin
+                      for i := 0 to cboSurgery.Items.Count - 1 do
+                        if uppercase(cboSurgery.Text) = uppercase(piece(cboSurgery.Items[i],'^',2)) then
+                          begin
+                            cboSurgery.ItemIndex := i;
+                            Break;
+                          end;
+                      cboSurgeryChange(self);
+                    end;
                 end;
             end;
@@ -669,4 +710,104 @@
       DisableDiagTestControls;
     end;
+    cList.Clear;
+    if (Length(cboSurgery.ItemID) > 0) then
+      begin
+        for j := 0 to uSelectedItems.Count - 1 do
+          begin
+            xLabTest := TLabTest.Create(piece(uSelectedItems[j],'^',2), Responses);
+            if (piece(uSelectedItems[j],'^',1) = '0') and (not(piece(uSelectedItems[j],'^',3)='')) and (StrToInt(piece(uSelectedItems[j],'^',3)) > 0) and (piece(cboSurgery.Items[cboSurgery.ItemIndex],'^',3) = '1') then
+              begin
+                cList.Add(xLabTest.TestName + '^' + piece(uSelectedItems[j],'^',3));
+              end;
+            xLabTest.Free;
+          end;
+      end;
+    if (uChangingMSBOS = false) and (cList.Count > 0) then
+      begin
+        lblNoBloodReq.Visible := true;
+        with Application do
+          begin
+            NormalizeTopMosts;
+            aMSBOSContinue :=
+              MessageBox(PChar('No blood is required for the surgical procedure: ' + cboSurgery.text +
+               '.' + CRLF +
+               'If you still need to order any components, please enter a justification in the Comment box.'
+                + CRLF + CRLF + 'Do you want me to remove ALL the component orders you''ve just entered? '),
+               PChar('No Blood Required'),MB_YESNO);
+            RestoreTopMosts;
+          end;
+        if aMSBOSContinue = 6 then
+          begin
+            tQuantity.Text := '';
+            for j := uSelectedItems.Count - 1 downto 0 do
+              begin
+                if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '0') then
+                  begin
+                    lvSelectionList.Items[j].Delete;
+                    uSelectedItems.Delete(j);
+                    Responses.Update('ORDERABLE', (j+1) ,'', '');
+                    Responses.Update('MODIFIER', (j+1), '', '');
+                    Responses.Update('QTY', (j+1), '', '');
+                  end;
+              end;
+            cboAvailComp.Text := '';
+            cboAvailComp.ItemIndex := -1;
+            cboModifiers.Text := '';
+            cboModifiers.ItemIndex := -1;
+            lblNoBloodReq.Visible := false;
+            //if fODBBank. Active then cboAvailTest.SetFocus;
+            lblTNS.Caption := '';
+            lblTNS.Visible := false;
+            DisableComponentControls;
+          end;
+      end;
+      for i := 0 to lvSelectionList.Items.Count - 1 do
+        begin
+          if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
+            begin
+              uGetTnS := 0;
+              aGotTNS := true;
+              uDfltUrgency := cboUrgency.ItemID;
+              lblTNS.Caption := '';
+              lblTNS.Visible := false;
+              memMessage.Text := '';
+              pnlMessage.Visible := false;
+              pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+              if uTNSOrders.Count > 0 then
+                begin
+                  for j := 0 to uTNSOrders.Count - 1 do
+                    aTNSString := aTNSString + CRLF + uTNSOrders[j];
+                  with Application do
+                    begin
+                      NormalizeTopMosts;
+                      aTNS :=
+                        MessageBox(PChar(aTNSString + CRLF + CRLF +
+                           'Do you wish to cancel this request for Type & Screen?'),
+                           PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
+                           MB_YESNO);
+                      RestoreTopMosts;
+                      if aTNS = 6 then
+                        begin
+                          lvSelectionList.ItemIndex := i;
+                          lvSelectionListClick(self);
+                          btnRemoveClick(self);
+                          break;
+                        end;
+                    end;
+                end;
+              break;
+            end;
+        end;
+      if uSelectedItems.Count < 1 then uGetTNS := 0;
+
+      for i := uSelectedItems.Count - 1 downto 0 do
+        begin
+          if (aGotTNS = false) and not(piece(uSelectedItems[i],'^',1) = '1') and (uTNSOrders.Count < 1) and (piece(uSelectedItems[i],'^',5) = '1') then //CQ 17349
+            begin
+              uGetTnS := 1;
+              break;
+            end;
+        end;
+
     CurAdd := 1;
     for i := 0 to uSelectedItems.Count - 1 do
@@ -689,5 +830,14 @@
               else
                 begin
-                  cboUrgency.ItemIndex := 1;
+                  cboUrgency.ItemIndex := 2;
+                  for j := 0 to cboUrgency.Items.Count - 1 do
+                    begin
+                      aUrgText := cboUrgency.Items[j];
+                      if aUrgText = '9^ROUTINE' then    // Find urgency default of ROUTINE
+                        begin
+                          cboUrgency.ItemIndex := j;
+                          break;
+                        end;
+                    end;
                   Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
                   cboUrgencyChange(self);
@@ -696,183 +846,18 @@
         Inc(CurAdd);
       end;
-    for i := 0 to lvSelectionList.Items.Count - 1 do
-      begin
-        if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
-          begin
-            if uTNSOrders.Count > 0 then
-              begin
-                for j := 0 to uTNSOrders.Count - 1 do
-                  aTNSString := aTNSString + CRLF + uTNSOrders[j];
-                with Application do
-                  begin
-                    NormalizeTopMosts;
-                    aTNSDays := TNSDaysBack;
-                    aTNS :=
-                      MessageBox(PChar(aTNSString + CRLF + CRLF +
-                                 'Do you wish to continue with this request for Type & Screen?'),
-                                 PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
-                                 MB_YESNO);
-                    RestoreTopMosts;
-                    if aTNS = 7 then
-                      begin
-                        lvSelectionList.ItemIndex := i;
-                        lvSelectionListClick(self);
-                        btnRemoveClick(self);
-                        break;
-                      end;
-                  end;
-              end;
-            break;
-          end;
-      end;
-  {if OrderAction in [ORDER_COPY, ORDER_EDIT, ORDER_QUICK] then with Responses, ALabTest do
-    begin
-      if OrderAction in [ORDER_QUICK, ORDER_EDIT] then uQuickInProcess := 1;
-      AnInstance := NextInstance('ORDERABLE', 0);
-      while AnInstance > 0 do
-        begin
-          AResponse := FindResponseByName('ORDERABLE', AnInstance);
-          if AResponse <> nil then
-            begin
-              sub := GetSubtype(AResponse.EValue);
-              if sub = 't' then
-                begin
-                  SetControl(cboAvailTest,        'ORDERABLE', AnInstance);
-                  ALabTest := TLabTest.Create(cboAvailTest.ItemID, Responses);
-                end
-              else
-                begin
-                  SetControl(cboAvailComp,        'ORDERABLE', AnInstance);
-                  ALabTest := TLabTest.Create(cboAvailComp.ItemID, Responses);
-                end;
-              //SetControl(cboTests,           'ORDERABLE', AnInstance);
-              //ALabTest := TLabTest.Create(cboTests.ItemID, Responses);
-              if ALabTest = nil then Exit;  // Causes access violation
-              //sub := GetSubtype(ALabTest.TestName);
-              if AnInstance = 1 then
-                begin
-                  DetermineCollectionDefaults(Responses);
-                  SetControl(cboReasons,         'REASON', AnInstance);
-                  SetControl(chkConsent,         'YN', AnInstance);
-                  SetControl(cboSurgery,         'MISC', AnInstance);
-                  //SetControl(cboCollType,        'COLLECT', AnInstance);
-                  //SetControl(cboCollTime,        'START', AnInstance);
-                  SetControl(calWantTime,        'DATETIME', AnInstance);
-                  //LoadUrgency(cboCollType.ItemID, cboUrgency);
-                  SetControl(cboUrgency,         'URGENCY', AnInstance);
-                  Urgency := cboUrgency.ItemIEN;
-                  if (Urgency = 0) and (cboUrgency.Items.Count = AnInstance) then
-                    begin
-                      cboUrgency.ItemIndex := 0;
-                      Urgency := cboUrgency.ItemIEN;
-                    end;
-                  i := 1 ;
-                  AResponse := Responses.FindResponseByName('COMMENT',i);
-                  while AResponse <> nil do
-                      begin
-                        if Length(AResponse.Evalue) > 0 then
-                          Comment.Add(AResponse.EValue);
-                        Inc(i);
-                        AResponse := Responses.FindResponseByName('COMMENT',i);
-                      end ;
-                end;
-              if sub = 't' then with ALabTest do      //DIAGNOSTIC TEST
-                begin
-                  Changing := True;
-                  DisableComponentControls;
-                  EnableDiagTestControls;
-                  LRORDERMODE := TORDER_MODE_DIAG;
-                  with Responses do
-                    begin
-                      StatusText('Initializing Order');
-                      AResponse := FindResponseByName('ORDERABLE', AnInstance);
-                      if AResponse <> nil then
-                        sub1 := GetSubtype(AResponse.EValue);
-                      if sub1 = 't' then
-                        begin
-                          SetControl(cboAvailTest,       'ORDERABLE', AnInstance);
-                          //SetControl(cboTests,           'ORDERABLE', AnInstance);
-                          //DetermineCollectionDefaults(Responses);   //cboCollType = COLLECT , calCollTime = START
-                          cboAvailTestSelect(self);
-                        end;
-                    end;
-                  Changing := False;
-                  if ObtainCollSamp then
-                    begin
-                      //For BloodBank orders, this condition should never occur
-                    end
-                  else
-                    begin
-                      with ALabTest do
-                        with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
-                          begin
-                            x := '' ;
-                            for i := 0 to WardComment.Count-1 do
-                            x := x + WardComment.strings[i]+#13#10 ;
-                            pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
-                            OrderMessage(x) ;
-                          end ;
-                    end;
-                end;
-              if sub = 'c' then with ALabTest do  //COMPONENT
-                begin
-                  Changing := True;
-                  DisableDiagTestControls;
-                  EnableComponentControls;
-                  LRORDERMODE := TORDER_MODE_COMP;
-                  with Responses do
-                    begin
-                      StatusText('Initializing Order');
-                      AResponse := FindResponseByName('ORDERABLE', AnInstance);
-                      if AResponse <> nil then
-                        sub1 := GetSubtype(AResponse.EValue);
-                      if sub1 = 'c' then
-                        begin
-                          SetControl(cboAvailComp,       'ORDERABLE', AnInstance);
-                          //SetControl(cboTests,           'ORDERABLE', AnInstance);
-                          SetControl(cboModifiers,       'MODIFIER', AnInstance);
-                          SetControl(tQuantity,          'QTY', AnInstance);
-                          //DetermineCollectionDefaults(Responses);
-                          cboAvailCompSelect(self);
-                        end;
-                    end;
-                  Changing := False;
-                end;
-              with ALabTest do
-                begin
-                  if ObtainComment then
-                    LoadRequiredComment(FCmtTypes.IndexOf(CurReqComment))
-                  else
-                    DisableCommentPanels;
-                  x := '' ;
-                  for i := 0 to CurWardComment.Count-1 do
-                    x := x + CurWardComment.strings[i]+#13#10 ;
-                  i :=  IndexOfCollSamp(CollSamp);
-                  if i > -1 then with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
-                    for i := 0 to WardComment.Count-1 do
-                      x := x + WardComment.strings[i]+#13#10 ;
-                  pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
-                  if Length(x) > 0 then
-                    begin
-                      OrderMessage(x) ;
-                    end;
-                end;
-              StatusText('');
-              Changing := True;
-              //if not(FOrderAction = ORDER_EDIT) then DetermineCollectionDefaults(Responses);
-              Changing := False;
-            end;
-          AnInstance := NextInstance('ORDERABLE', AnInstance);
-        end; //while AnInstance - ORDERABLE
-      DisableComponentControls;
-      DisableDiagTestControls;
-      uQuickInProcess := 0;
-    end;  }
+    if uGetTnS = 1 then
+      begin
+        lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+        lblTNS.Visible := true;
+        memMessage.Text := 'TYPE + SCREEN must be added to order';
+        pnlMessage.Visible := true;
+        pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+      end
+      else pnlDiagnosticTests.Caption := 'Diagnostic Tests';
   finally
     aList.Free;
+    cList.Free;
     aTests.Free;
   end;
-  edtResults.Height := 247;
-  edtInfo.Height := 247;
   if lvSelectionList.Items.Count > 0 then
     begin
@@ -881,4 +866,6 @@
       memOrder.Visible := True;
       GroupBox1.Visible := False;
+      lvSelectionList.Items[0].Selected := true;
+      lvSelectionListClick(self);
     end;
 end;
@@ -890,14 +877,17 @@
   i: integer;
   x,sub,sub1,aTNSString: string;
-  aList: TStringList;
-  aGotIt: boolean;
+  aList, cList: TStringList;
+  aGotIt, aGotTNS: boolean;
   aTests: TStringList;
   ListItem: TListItem;
-  aName, aMsg, aStr, aModifier, aReason, aSurgery, aCollTime, aTestYes, aSpecimen, aTypeScreen: String;
-  CurAdd, j, k, getTest, TestAdded, aMSBOS, aMSBOSContinue, aTNS, aTNSDays: Integer;
+  xLabTest: TLabTest;
+  aName, aMsg, aStr, aModifier, aReason, aSurgery, aCollTime, aTestYes, aSpecimen, aSpecimenUID, aSpecimenReq, aTypeScreen, aUrgText: String;
+  CurAdd, j, k, getTest, TestAdded, aMSBOS, aMSBOSContinue, aTNS: Integer;
 begin
   inherited;
   aList := TStringList.Create;
+  cList := TStringList.Create;
   aTests := TStringList.Create;
+  pgeProduct.ActivePageIndex := TI_COMPONENT;
   try
     aModifier := '';
